module Embulk
  module Parser

    class Mahout < ParserPlugin
      Plugin.register_parser("mahout", self)

      def self.transaction(config, &control)
        # configuration code:
        task = {
          "command" => config.param("command", :string, default: "recommenditembased"),                     # integer, required
          "schema" => config.param("schema", :array)
        }

        columns = task["schema"].each_with_index.map do |col, index|
          Column.new(index, col["name"], col["type"].to_sym)
        end

        yield(task, columns)
      end

      def init
        @command = task["command"]
        @col = task["columns"]
      end

      def run(file_input)
        while file = file_input.next_file

          text = file.read
          text.each_line do |row|

            record = []

            user_id = row.match(/^\d*/)[0]
            record.push(user_id)
            recommend_items = row.scan(/(\d*):(\d*\.\d*)/)
            recommend_items.each do |item|
              record += [item[0], item[1]]
            end
            page_builder.add(record)

          end

        end
        page_builder.finish
      end
    end

  end
end
